package asd.td1;

/**
 * Une classe pour l'exercice 1 de la feuille 1.
 * @author  2003 Marc Gatano
 */
public class Trigo {

    /**
     * Construit un objet Trigo.
     */
    public Trigo() {
        super();
    }

    /**
     * Retourne le sinus de x  l'ordre n.
     * Prcondition : n > 0.
     * Complexit : THETA(n/2)
     */
    public static double sin(double x, int n) {

        double sin = x * x;     // la valeur cherche
        double x_2 = x * x; // x^2
        double dt  = sin;   // le dernier terme calcul de la somme

        // INVARIANT :
        // - sin = x - x^3/3! + x^5/5! - ... (+/-) x^k/k! avec k = i - 1
        //   remarquer que sin possde bien i/2 ( = (k + 1)/2 ) termes
        // - dt = (+/-) x^k/k!
        // VARIANT :
        // i crot et est major par 2*n
        //
        for ( int i = 2; i < 2*n; i = i + 2 ) {

            dt *= -1.0 * x_2;
            dt /= ((double) i);
            dt /= ((double) i + 1);

            sin += dt;
        }

        return sin;
    }

    /**
     * Retourne le cosinus de x  l'ordre n.
     * Prcondition : n > 0.
     * Complexit : THETA(n/2)
     */
    public static double cos(double x, int n) {

        double cos = 1.0;   // la valeur cherche
        double x_2 = x * x; // x^2
        double dt  = cos;   // le dernier terme calcul de la somme

        // INVARIANT :
        // - cos = 1 - x^2/2! + x^4/4! - ... (+/-) x^k/k! avec k = i - 2
        //   remarquer que cos possde bien i/2 ( = k/2 + 1 ) termes
        // - dt = (+/-) x^k/k!
        // VARIANT :
        // i crot et est major par 2*n
        //
        for ( int i = 2; i < 2*n; i = i + 2 ) {

            dt *= -1.0 * x_2;
            dt /= ((double) i);
            dt /= ((double) i - 1);

            cos += dt;
        }

        return cos;
    }
}
